JD Edwards Anypoint&trade; Studio Connector Demo (Invoke Business Function)
==================================================================

## Introduction

The current demo application provides a simple workflow to:

* Add an employee record into JDE
* Fetch employee data from JDE A/B record.

Both operations will invoke to A/B Master Business Function on EnterpriseOne Server

## Prerequisites

* Java 7
* Anypoint Studio 5.4.x
* Mule Runtime 3.7.0 EE or higher
* DataWeave
* JDE Connector User manual has been read
* JDE bundle must be created. (See [User Manual Site](http://modusintegration.github.io/mule-connector-jde/1.1.0/functional/user-manual.html): _Generate Bundle_)
* JDE standards ini files (See [User Manual Site](http://modusintegration.github.io/mule-connector-jde/1.1.0/functional/user-manual.html): _Copy JDE ini Files to the Projet_)
* JDE Enterprise Server is reachable from your location

## Import the project

* Go to **File > Import**
* Select **Anypoint Studio Project from External Location** (under the parent folder "Anypoint Studio")

![Menu](images/jde_connection_config01.png)

* Provide the root path to the demo project folder.
* Select Mule Runtime (3.7.x EE).

![File Selection](images/jde_connection_config02.png)

* Click **Finish**.  
* Set Cookbook credentials inside the file `src/main/app/mule-app.properties`.

```
jde.user=<JDE_USER>
jde.password=<JDE_PASSWORD>
jde.environment=<JDE_ENVIRONMENT>
jde.role=<JDE_ROLE>
jde.imagefoldercache=<LOCAL_FOLDER>
```

* Copy **JDE ini Files** inside the Project.

Put the files inside the project folder in the folder:

* source/main/resource
* root folder of the project

![Test Connection](images/jde_connection_config06.png)


* Inside the Global Elements view, double-click the **JDE Configuration** component.

![Test Connection](images/jde_connection_config03.png)

Add JDE Bundle jar file.

![Test Connection](images/jde_connection_config04.png)

Click "Test Connection".

![Test Connection](images/jde_connection_config05.png)

* A successful message should pop-up.

![Test Connection](images/jde_connection_config07.png)

* Save the project and from the Project Folder, Select **Run as Mule Application**

* Open a browser and access the URL `http://localhost:8081`. You should see the demo application deployed:

![Workflow Demo](images/jde_connection_run01.png)

## About the flows

**1. Html_Form_Flow:** renders the HTML form with a `parseTemplate` component.

![Flow HMTL Form](images/jde_connection_flow01.png)

**2. Add Employee_Flow:** executes **A/B Master Business Function** in Add Mode

![Flow Get](images/jde_connection_flow02.png)

**3. Get Employee Data:** retrieves the information of a Employee invoking **A/B Master Business Function** in Inquired Mode

![Flow Get](images/jde_connection_flow03.png)

**4. Choice_Exception_Strategy:** global exception strategy that handles every exception that may arise at runtime and forwards it to the HTML form for better troubleshooting in the front-end side.

![Flow 6 Exception](images/jde_connection_flow04.png)

## Run the demo

### Query
* Click the link **"Query"**.
* Enter the Employee Number and Employee Name.

![Flow Get](images/jde_connection_run02.png)

* Click the **"Add Employee"** button and wait until confirmation.

![Flow Get](images/jde_connection_run03.png)

* To fetch employee data, enter employee number:

![Flow Get](images/jde_connection_run04.png)

* Click the **"Get Employee Data"** button and wait a few moments to finish processing.
* The details of the employee will be displayed in the **Description** textarea.

![Flow Get](images/jde_connection_run05.png)

* **Congratulations!** You have successfully run this demo. Continue exploring the connector by playing with other available [demos](http://modusintegration.github.io/mule-connector-jde/) or visiting the [JD Edwards Connector Documentation Site](http://modusintegration.github.io/mule-connector-jde/1.1.0/functional/user-manual.html) and  the [DevKit Cookbook Tutorial](http://mulesoft.github.io/mule-cookbook-tutorial).
